/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: LCD_drive.c
* ߲		: IAR EWAAVR 2.28a/3.10a
* 			: $Revision: 1.1 $
* t			: $Date: 28. april 2004 15:17:00 $
* XV		: $Author: ltwa $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega16
*
* pLq		: AVR241 : WI/OgpLCD\̒ڋ쓮
*
* 			: ̧ق͕WI/Ogp72LCD\pLCDײފ
*				  ܂݂܂B֐͏[ȐI/OǂAVRϲ ۰ׂł
*				  gp邩܂B
*
******************************************************************************/

#include <iom16.h>
#include <inavr.h>

//	* Sϐ *

struct LCDtype				// \ւ̏o͗pSϐ
  {
	char digit1;
	char digit2;
  	} LCD;

//	* LCD_print()֐ *

char LCD_print(char digit, char ASCII_data){
  char    Data_var;

  if( !(digit == 1 || digit == 2) ||					// ԍ܂͌1_wŎsƋɕA
  ( (ASCII_data & (1 << 7)) && digit == 1 )  )return 0;
  else{
	switch(ASCII_data & ~(1 << 7)){			// _ޯĂ𗎂ƂASCIIΉLCD͗ll擾
	  case    '0':    Data_var = 0x3F;
		break;  
	  case    '1':    Data_var = 0x06;
		break;
	  case    '2':    Data_var = 0x5B;
		break;
	  case    '3':    Data_var = 0x4F;
		break;
	  case    '4':    Data_var = 0x66;
		break;
	  case    '5':    Data_var = 0x6D;
		break;
	  case    '6':    Data_var = 0x7D;
		break;
	  case    '7':    Data_var = 0x07;
		break;
	  case    '8':    Data_var = 0x7F;
		break;
	  case    '9':    Data_var = 0x6F;
		break;
	  case    'A':    Data_var = 0x77;
		break;
	  case    'B':    Data_var = 0x7C;
		break;
	  case    'C':    Data_var = 0x39;
		break;
	  case    'D':    Data_var = 0x5E;
		break;
	  case    'E':    Data_var = 0x79;
		break;
	  case    'F':    Data_var = 0x71;
		break;
	  case    ' ':    Data_var = 0;
		break;
	  default:        return 0;				// ͈͊OASCIIlŎsƋɕA
	}
  }
  if(digit == 1){							// 1ŁA1pLCD͗llXV
	LCD.digit1 = Data_var;
  }
  else{										// 2ŁA_A2pLCD͗llXV
	LCD.digit2 = Data_var | (ASCII_data & (1 << 7));
  }
  return 1;									// ƋɕA
}

//	* LCD_update()֐ *

void LCD_update(void){
  static char sequence=0;

  if(!sequence){					// ڰёOŁA
	PORTB = LCD.digit2;				// 2쓮lo͊Jn
	PORTD = LCD.digit1 &= ~0x80;	// COM=0ƋɌ1쓮lo͊Jn
	sequence = 1;					// Ԕԍڰь㔼ɕύX
  }
  else{								// ڰь㔼ŁA
	PORTB = PORTB ^ 0xFF;			// 2쓮l]o͊Jn
	PORTD = PORTD ^ 0xFF;           // COM=1ƋɌ1쓮l]o͊Jn
	sequence = 0;					// ԔԍڰёOɕύX
  }
}
